/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : race_wb.c
Last edit : 10/20/92
Created   :
Version   : 1.6

History   :

Does      : Work-horse of profession choosing.
*/
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <curses.h>

#include <paths.h>
#include <limits.h>

#include "race_main.h"

extern char 	*get_word(FILE *src);
extern void 	siemen(void);
extern int 	sattuma(int,int);
extern char	*mstrtok(char *, char *);

do_race(char *arg)
{
  FILE 			*src=NULL;
  FILE 			*dst=NULL;
  char 			*t=NULL;
  int 			lkm=0;
  struct race_main 	*races=NULL;
  int 			i=0;
  int 			ok=0;
  int 			m=0;
  char 			*directory=NULL;
  int 			len = 0;
  char 			*dirri=NULL;
  char 			*name=NULL;

  directory = mstrtok(arg," \t\n\0");
  if(!directory) {
    fprintf(stderr,"race_wb.c/mstrtok()");
    exit(0);
  }

  len = strlen(directory) + strlen(SAVE) + 2;
  dirri = malloc(len);
  if(!dirri) {
    perror("race_wb.c/do_race()");
    exit(0);
  }

  len = strlen(directory) + 14 + 5;
  name = malloc(len);
  if(!name) {
    perror("race_wb/do_race()");
    exit(0);
  }

  sprintf(name,"%s.race",directory);
  sprintf(dirri,"%s/%s",SAVE,directory);    

  if(chdir(dirri)) 
    if(mkdir(dirri,0755)) {
      printf("Unable to make directory\n");
      exit(0);
    } else
      chdir(dirri);

  siemen();
  src = fopen(RACES,"r");
  if(!src) {
    perror(RACES);
    exit(0);
  }
  t = get_word(src);

  if(!t) 
    return;

  lkm = atoi(t);
  races = (struct race_main *)calloc(lkm,sizeof(struct race_main));

  if(!races) {
    perror("race_wb/do_race()");
    exit(0);
  }

  for(i=0; i < lkm; i++) {
    move(21,1);
    printw("Reading races: %3i (%3i)   ", i+1,lkm);
    refresh();
    if(get_race(&races[i],src)) break;
    races[i].nro = i;	
  }   
  fclose(src);

  clear();
  i = 0;
  refresh();
  ok =0;
  while(!ok) {
    put_race_main(&races[i]);
    m = getch();
    m = isupper(m) ? tolower(m) : m;
    switch(m) {
      case 'x':		/* Exit. */
	ok = 1;
	break;
      case 'n':		/* Next. */
	i++;
	if(i == lkm)
	  i = 0;
	break;
      case 'p':		/* Previous. */
	i--;
	if(i == -1)
	  i = lkm-1;
	break;
      case 'l':		/* Letter. */
	move(16,43);
	printw("Letter?");
	refresh();
	while(1) {
	  m = getch();
	  m = islower(m) ? toupper(m) : m;
	  if( m >= 'A' && m <= 'Z')
	    break;
	}
	move(16,43);
	clrtoeol();
	refresh();
	while(m > races[i++].race[0] && i < lkm);
 	if(i >=lkm) i = lkm -1;
	while(m < races[i--].race[0] && i > -1);		
	if(i <=-1) i = 0;
	break;
      case 'r':		/* Random. */
	i = sattuma(0,lkm-1);
	break;	
      case 'a':		/* Accept. */
	dst = fopen(name,"w");
	if(!dst) {
	  move(16,43);
	  printw("Sorry, couldn't open");
	  move(17,43);
	  printw("save file.");
	  move(18,43);
	  printw("Press a key.");
	  refresh();
	  getch();
        }
        else {
	  fwrite(&races[i],sizeof(struct race_main),1,dst); 	
	  fclose(dst);
	  move(16,43);
	  printw("Race saved");
	  move(17,43);
	  printw("and accepted.");
	  move(18,43);
	  printw("Press a key.");
	  getch();
        }
	move(16,43);
	clrtoeol();
	move(17,43);
	clrtoeol();
	move(18,43);
	clrtoeol();
	refresh();
    }
  }
  return;
} 

int get_race(struct race_main *m, FILE *src)
{
  char *t;
 
  if(!(t = get_word(src))) return -1;
  sprintf(m->race,"%-22s",t);

  if(!(t = get_word(src))) return -1;
  m->st = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->qu = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->pr = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->in = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->em = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->co = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->ag = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->sd = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->re = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->mq = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->ess = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->cha = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->men = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->poi = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->dis = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->lang = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->dice = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->max = atoi(t);

  if(!(t = get_word(src))) return -1;
  m->bag = atoi(t);

  return 0;
}
